//
//  SecondViewController.m
//  ValueSample
//
//  Created by eien.support@gmail.com on 12/03/29.
//  Copyright (c) 2012年 __MyCompanyName__. All rights reserved.
//

#import "SecondViewController.h"
#import "AppDelegate.h"

extern BOOL firstValue;


@interface SecondViewController ()

@property (weak, nonatomic) IBOutlet UITextField *singleView;
@property (weak, nonatomic) IBOutlet UISwitch *globalView;
@property (weak, nonatomic) IBOutlet UISegmentedControl *defaultsView;
@property (weak, nonatomic) IBOutlet UITextView *resultsView;

@end

@implementation SecondViewController
@synthesize singleView;
@synthesize globalView;
@synthesize defaultsView;
@synthesize resultsView;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        self.title = NSLocalizedString(@"Second", @"Second");
        self.tabBarItem.image = [UIImage imageNamed:@"second"];
    }
    return self;
}
							
- (void)viewDidLoad
{
    [super viewDidLoad];
    [globalView addTarget:self
                   action:@selector(switchDidChanged:)
         forControlEvents:UIControlEventValueChanged];
    [defaultsView addTarget:self
                     action:@selector(segmenetDidChanged:)
           forControlEvents:UIControlEventValueChanged];
}

- (void)viewDidUnload
{
    [self setGlobalView:nil];
    [self setSingleView:nil];
    [self setDefaultsView:nil];
    [self setResultsView:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return UIInterfaceOrientationIsPortrait(interfaceOrientation);
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    globalView.on = firstValue;
    
    AppDelegate *appDelegate;
    appDelegate = (AppDelegate*)[[UIApplication sharedApplication] delegate];
    singleView.text = appDelegate.singleString;
    
    NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
    if ( [[userDefaults valueForKey:@"selectedSegmentIndex"] intValue] == 0 ) {
        defaultsView.selectedSegmentIndex = 0;
    } else {
        defaultsView.selectedSegmentIndex = 1;
    }
}

-(BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [textField resignFirstResponder];
    return YES;
}

-(void)textFieldDidEndEditing:(UITextField *)textField
{
    AppDelegate *appDelegate;
    appDelegate = (AppDelegate*)[[UIApplication sharedApplication] delegate];
    appDelegate.singleString = singleView.text;
}

-(void)segmenetDidChanged:(id)sender
{
    NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
    [userDefaults setValue:[NSNumber numberWithInt:defaultsView.selectedSegmentIndex]
                    forKey:@"selectedSegmentIndex"];
    [userDefaults synchronize];
}

-(void)switchDidChanged:(id)sender
{
    firstValue = globalView.on;
}

@end
